/* EOCIRQ.C */

#include <conio.h>
#include <graphics.h>
#include <dos.h>
#include <string.h>
#include <stdio.h>
#include <process.h>
#include <alloc.h>

#ifdef __cplusplus
#define __CPPARGS ...
#else
#define __CPPARGS
#endif

int teste=1;
int matriz[1000];

void interrupt (*rotinavelha)(__CPPARGS);

// per_esq, per_sup, per_dir, per_inf - percentagens da tela relativas
//                                      aos extremos do grfico 
// gridx, gridy - nmero de grides a serem impressos nos eixos
// mensagem - ttulo do grfico
// fator_escala - excurso do grfico
// bipolar - igual a 1 para amostras positivas e negativas
// npontos - nmero de amostras
// matr - buffer com os valores inteiros das amostras

void file_graf(int per_esq,int per_sup,int per_dir,int per_inf,int
gridx,int gridy,char far *mensagem,int fator_escala,char bipolar,
long npontos,int far *matr)
{
int direita,esquerda,superior,inferior;
long i,j,k,x0,y0,x1,y1;
esquerda=(per_esq*(getmaxx()/10))/10;
superior=(per_sup*(getmaxy()/10))/10;
direita=(per_dir*(getmaxx()/10))/10;
inferior=(per_inf*(getmaxy()/10))/10;
setlinestyle(SOLID_LINE,0,THICK_WIDTH);
setcolor(BLUE);
rectangle(esquerda,superior,direita,inferior);
i=inferior-superior;
setlinestyle(DASHED_LINE,0,NORM_WIDTH);
for(j=0;j<gridx;j++)
line((int)esquerda,(int)(inferior-(j+1)*i/(gridx+1)),(int)direita,
	(int)((inferior-j+1)*i/(gridx+1)));
i=direita-esquerda;
for(j=0;j<gridy;j++)
	line((int)(esquerda+(j+1)*i/(gridy+1)),(int)inferior,
		(int)(esquerda+(j+1)*i/(gridy+1)),(int)superior);
setcolor(MAGENTA);
outtextxy(esquerda+2,superior+2,mensagem);
if (bipolar==0)   i=inferior;
if (bipolar==1)   i=(inferior+superior)/2;
setcolor(YELLOW);
setlinestyle(SOLID_LINE,0,NORM_WIDTH);
x0=esquerda;
y0=i-((long)(matr[0]*(inferior-superior)))/fator_escala;
for (k=1;k<npontos;k++)
{
	x1=esquerda+((long)(k*(direita-esquerda)))/(npontos-1);
		j=matr[(int)k];
		y1=i-((long)(j*(inferior-superior)))/fator_escala;
		line((int)x0,(int)y0,(int)x1,(int)y1);
	x0=x1;
	y0=y1;
}
}

int grafico (int *matriz)
{
char mensagem[20];
int gdriver=VGA;
int gmode=VGAHI;
textmode(BW80);
initgraph(&gdriver,&gmode,"");
setbkcolor(BLACK);
cleardevice( );
settextstyle(DEFAULT_FONT,HORIZ_DIR,2);
settextjustify(LEFT_TEXT,TOP_TEXT);
strcpy(mensagem,"Amostras");
file_graf(5,15,95,70,1,3,mensagem,2048,1,1000,matriz);
while (!(getch( )==0x1B));
restorecrtmode();
return(0);
}

int cont=0;
void interrupt conversorAD (__CPPARGS)
{
	matriz[cont]=inportb(0x301);	/* l sada do A/D */
	cont++;				/* conta interrupes */
outportb (0x20,0x20);		/* libera controlador mestre */
if (cont==1000) {
	outportb(0x300, 0x00);	/* desabilita o conversor */
		teste=0;
				}
}

void habilitaIRQ5 (void)
{
int mascara;
mascara=inportb(0x21);
mascara=(mascara & 0xDF);
outportb(0x21, mascara);
}

void desabilitaIRQ5 (void)
{
int mascara;
mascara=inportb(0x21);
mascara=(mascara | 0x20);
outportb(0x21, mascara);
}

void main (void)
{
	int palavra=0;
	rotinavelha=getvect(0x0D);	/* salva manipulador antigo */
	printf("Selecione o expoente do divisor de frequencia: (0 a 15)");
	scanf("%d",&palavra);		/* l taxa de amostragem */
	palavra=palavra<<4;
	palavra=palavra|8;		/* compe 300h para entrada IN0 */
	disable( );			/* desabilita interrupes */
	setvect (0x0d,conversorAD);	/* instala manipulador */
	enable( );			/* habilita interrupes */
	habilitaIRQ5( );			/* habilita IRQ5 */
	outportb(0x300, palavra);	/* escreve taxa e canal de amost.*/
	while (teste) { };			/* espera finalizar interrupes */
	grafico(matriz);			/* imprime grfico na tela */
	desabilitaIRQ5( );		/* desabilita IRQ5 */
	disable( );			/* desabilita interrupes */
	setvect (0x0D,rotinavelha);	/* restaura manipulador antigo */
	enable( );			/* habilita interrupes */
	printf("fim do programa");
}

