
/* IRQ5IRQ9.C */

#include <stdio.h>
#include <dos.h>
#include <conio.h>

#ifdef __cplusplus
#define __CPPARGS ...
#else
#define __CPPARGS
#endif

void interrupt(*rotinaantiga1)(__CPPARGS);
void interrupt(*rotinaantiga2)(__CPPARGS);

void interrupt IRQ5 (__CPPARGS)
{
printf("execucao da IRQ5\n");
outportb(0x300,0x10);	/* apaga pedido da IRQ5 por SD4 */
outportb(0x20,0x20);	/* libera controlador mestre */
}

void interrupt IRQ9 (__CPPARGS)
{
printf("execucao da IRQ9\n");
outportb(0x300,0x08); 	/* apaga pedido da IRQ5 por SD3 */
outportb(0xA0,0x20);	/* libera controlador escravo */
outportb(0x20,0x20);	/* libera controlador mestre */
}

void instala(void)       /* rotina para instalar ambos os manipuladores */
{
rotinaantiga1=getvect(0x0D);	/* salva manipulador da IRQ5*/
disable( );			/* desabilita interrupes */
setvect(0x0D,IRQ5);		/* instala manipulador da IRQ5*/
rotinaantiga2=getvect(0x71); 	/* salva manipulador da IRQ9*/
setvect(0x71,IRQ9); 		/* instala manipulador da IRQ9*/
outportb(0x21,inportb(0x21)&0xDF);	/* habilita IRQ5*/
outportb(0xA1,inportb(0xA1)&0xFD);	/* habilita IRQ9*/
enable( );			/* habilita interrupes */
}

void restauraantiga (void)	/* restaura manipuladores antigos */
{
disable( );
outportb(0x21,inportb(0x21)|0x20);	/* desabilita IRQ5*/
outportb(0xA1,inportb(0xA1)|0x02);	/* desabilita IRQ9*/
setvect(0x0D,rotinaantiga1);
setvect(0x71,rotinaantiga2);
enable( );
}

void main (void)
{
char tecla;
instala( );			/* instala manipuladores */
tecla=getch( );
while (tecla!=0x1B)		/* verifica se a tecla  ESC */
{
	outportb(0x300,0x01);	/*strobe para IRQs com SD0=1*/
	tecla=getch( );		/* espera toque de tecla */
}
restauraantiga( );		/* restaura manipuladores */
}
